<?php
/**
 * DeliveryService
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * DeliveryService Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class DeliveryService implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'DeliveryService';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'name' => 'string',
        'registered_at' => '\DateTime',
        'legal_info_company_name' => 'string',
        'legal_info_company_address' => '\Ensi\LogisticClient\Dto\Address',
        'legal_info_inn' => 'string',
        'legal_info_payment_account' => 'string',
        'legal_info_bik' => 'string',
        'legal_info_bank' => 'string',
        'legal_info_bank_correspondent_account' => 'string',
        'general_manager_name' => 'string',
        'contract_number' => 'string',
        'contract_date' => '\DateTime',
        'vat_rate' => 'int',
        'taxation_type' => 'int',
        'status' => 'int',
        'comment' => 'string',
        'apiship_key' => 'string',
        'priority' => 'int',
        'max_shipments_per_day' => 'int',
        'max_cargo_export_time' => 'string',
        'do_consolidation' => 'bool',
        'do_deconsolidation' => 'bool',
        'do_zero_mile' => 'bool',
        'do_express_delivery' => 'bool',
        'do_return' => 'bool',
        'do_dangerous_products_delivery' => 'bool',
        'do_transportation_oversized_cargo' => 'bool',
        'add_partial_reject_service' => 'bool',
        'add_insurance_service' => 'bool',
        'add_fitting_service' => 'bool',
        'add_return_service' => 'bool',
        'add_open_service' => 'bool',
        'pct' => 'int',
        'payment_methods' => 'int[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'name' => null,
        'registered_at' => 'date-time',
        'legal_info_company_name' => null,
        'legal_info_company_address' => null,
        'legal_info_inn' => null,
        'legal_info_payment_account' => null,
        'legal_info_bik' => null,
        'legal_info_bank' => null,
        'legal_info_bank_correspondent_account' => null,
        'general_manager_name' => null,
        'contract_number' => null,
        'contract_date' => 'date',
        'vat_rate' => null,
        'taxation_type' => null,
        'status' => null,
        'comment' => null,
        'apiship_key' => null,
        'priority' => null,
        'max_shipments_per_day' => null,
        'max_cargo_export_time' => null,
        'do_consolidation' => null,
        'do_deconsolidation' => null,
        'do_zero_mile' => null,
        'do_express_delivery' => null,
        'do_return' => null,
        'do_dangerous_products_delivery' => null,
        'do_transportation_oversized_cargo' => null,
        'add_partial_reject_service' => null,
        'add_insurance_service' => null,
        'add_fitting_service' => null,
        'add_return_service' => null,
        'add_open_service' => null,
        'pct' => null,
        'payment_methods' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'created_at' => false,
        'updated_at' => false,
        'name' => false,
        'registered_at' => false,
        'legal_info_company_name' => true,
        'legal_info_company_address' => true,
        'legal_info_inn' => true,
        'legal_info_payment_account' => true,
        'legal_info_bik' => true,
        'legal_info_bank' => true,
        'legal_info_bank_correspondent_account' => true,
        'general_manager_name' => true,
        'contract_number' => true,
        'contract_date' => true,
        'vat_rate' => true,
        'taxation_type' => true,
        'status' => false,
        'comment' => true,
        'apiship_key' => true,
        'priority' => false,
        'max_shipments_per_day' => true,
        'max_cargo_export_time' => true,
        'do_consolidation' => false,
        'do_deconsolidation' => false,
        'do_zero_mile' => false,
        'do_express_delivery' => false,
        'do_return' => false,
        'do_dangerous_products_delivery' => false,
        'do_transportation_oversized_cargo' => false,
        'add_partial_reject_service' => false,
        'add_insurance_service' => false,
        'add_fitting_service' => false,
        'add_return_service' => false,
        'add_open_service' => false,
        'pct' => false,
        'payment_methods' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'name' => 'name',
        'registered_at' => 'registered_at',
        'legal_info_company_name' => 'legal_info_company_name',
        'legal_info_company_address' => 'legal_info_company_address',
        'legal_info_inn' => 'legal_info_inn',
        'legal_info_payment_account' => 'legal_info_payment_account',
        'legal_info_bik' => 'legal_info_bik',
        'legal_info_bank' => 'legal_info_bank',
        'legal_info_bank_correspondent_account' => 'legal_info_bank_correspondent_account',
        'general_manager_name' => 'general_manager_name',
        'contract_number' => 'contract_number',
        'contract_date' => 'contract_date',
        'vat_rate' => 'vat_rate',
        'taxation_type' => 'taxation_type',
        'status' => 'status',
        'comment' => 'comment',
        'apiship_key' => 'apiship_key',
        'priority' => 'priority',
        'max_shipments_per_day' => 'max_shipments_per_day',
        'max_cargo_export_time' => 'max_cargo_export_time',
        'do_consolidation' => 'do_consolidation',
        'do_deconsolidation' => 'do_deconsolidation',
        'do_zero_mile' => 'do_zero_mile',
        'do_express_delivery' => 'do_express_delivery',
        'do_return' => 'do_return',
        'do_dangerous_products_delivery' => 'do_dangerous_products_delivery',
        'do_transportation_oversized_cargo' => 'do_transportation_oversized_cargo',
        'add_partial_reject_service' => 'add_partial_reject_service',
        'add_insurance_service' => 'add_insurance_service',
        'add_fitting_service' => 'add_fitting_service',
        'add_return_service' => 'add_return_service',
        'add_open_service' => 'add_open_service',
        'pct' => 'pct',
        'payment_methods' => 'payment_methods'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'name' => 'setName',
        'registered_at' => 'setRegisteredAt',
        'legal_info_company_name' => 'setLegalInfoCompanyName',
        'legal_info_company_address' => 'setLegalInfoCompanyAddress',
        'legal_info_inn' => 'setLegalInfoInn',
        'legal_info_payment_account' => 'setLegalInfoPaymentAccount',
        'legal_info_bik' => 'setLegalInfoBik',
        'legal_info_bank' => 'setLegalInfoBank',
        'legal_info_bank_correspondent_account' => 'setLegalInfoBankCorrespondentAccount',
        'general_manager_name' => 'setGeneralManagerName',
        'contract_number' => 'setContractNumber',
        'contract_date' => 'setContractDate',
        'vat_rate' => 'setVatRate',
        'taxation_type' => 'setTaxationType',
        'status' => 'setStatus',
        'comment' => 'setComment',
        'apiship_key' => 'setApishipKey',
        'priority' => 'setPriority',
        'max_shipments_per_day' => 'setMaxShipmentsPerDay',
        'max_cargo_export_time' => 'setMaxCargoExportTime',
        'do_consolidation' => 'setDoConsolidation',
        'do_deconsolidation' => 'setDoDeconsolidation',
        'do_zero_mile' => 'setDoZeroMile',
        'do_express_delivery' => 'setDoExpressDelivery',
        'do_return' => 'setDoReturn',
        'do_dangerous_products_delivery' => 'setDoDangerousProductsDelivery',
        'do_transportation_oversized_cargo' => 'setDoTransportationOversizedCargo',
        'add_partial_reject_service' => 'setAddPartialRejectService',
        'add_insurance_service' => 'setAddInsuranceService',
        'add_fitting_service' => 'setAddFittingService',
        'add_return_service' => 'setAddReturnService',
        'add_open_service' => 'setAddOpenService',
        'pct' => 'setPct',
        'payment_methods' => 'setPaymentMethods'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'name' => 'getName',
        'registered_at' => 'getRegisteredAt',
        'legal_info_company_name' => 'getLegalInfoCompanyName',
        'legal_info_company_address' => 'getLegalInfoCompanyAddress',
        'legal_info_inn' => 'getLegalInfoInn',
        'legal_info_payment_account' => 'getLegalInfoPaymentAccount',
        'legal_info_bik' => 'getLegalInfoBik',
        'legal_info_bank' => 'getLegalInfoBank',
        'legal_info_bank_correspondent_account' => 'getLegalInfoBankCorrespondentAccount',
        'general_manager_name' => 'getGeneralManagerName',
        'contract_number' => 'getContractNumber',
        'contract_date' => 'getContractDate',
        'vat_rate' => 'getVatRate',
        'taxation_type' => 'getTaxationType',
        'status' => 'getStatus',
        'comment' => 'getComment',
        'apiship_key' => 'getApishipKey',
        'priority' => 'getPriority',
        'max_shipments_per_day' => 'getMaxShipmentsPerDay',
        'max_cargo_export_time' => 'getMaxCargoExportTime',
        'do_consolidation' => 'getDoConsolidation',
        'do_deconsolidation' => 'getDoDeconsolidation',
        'do_zero_mile' => 'getDoZeroMile',
        'do_express_delivery' => 'getDoExpressDelivery',
        'do_return' => 'getDoReturn',
        'do_dangerous_products_delivery' => 'getDoDangerousProductsDelivery',
        'do_transportation_oversized_cargo' => 'getDoTransportationOversizedCargo',
        'add_partial_reject_service' => 'getAddPartialRejectService',
        'add_insurance_service' => 'getAddInsuranceService',
        'add_fitting_service' => 'getAddFittingService',
        'add_return_service' => 'getAddReturnService',
        'add_open_service' => 'getAddOpenService',
        'pct' => 'getPct',
        'payment_methods' => 'getPaymentMethods'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('registered_at', $data, null);
        $this->setIfExists('legal_info_company_name', $data, null);
        $this->setIfExists('legal_info_company_address', $data, null);
        $this->setIfExists('legal_info_inn', $data, null);
        $this->setIfExists('legal_info_payment_account', $data, null);
        $this->setIfExists('legal_info_bik', $data, null);
        $this->setIfExists('legal_info_bank', $data, null);
        $this->setIfExists('legal_info_bank_correspondent_account', $data, null);
        $this->setIfExists('general_manager_name', $data, null);
        $this->setIfExists('contract_number', $data, null);
        $this->setIfExists('contract_date', $data, null);
        $this->setIfExists('vat_rate', $data, null);
        $this->setIfExists('taxation_type', $data, null);
        $this->setIfExists('status', $data, null);
        $this->setIfExists('comment', $data, null);
        $this->setIfExists('apiship_key', $data, null);
        $this->setIfExists('priority', $data, null);
        $this->setIfExists('max_shipments_per_day', $data, null);
        $this->setIfExists('max_cargo_export_time', $data, null);
        $this->setIfExists('do_consolidation', $data, null);
        $this->setIfExists('do_deconsolidation', $data, null);
        $this->setIfExists('do_zero_mile', $data, null);
        $this->setIfExists('do_express_delivery', $data, null);
        $this->setIfExists('do_return', $data, null);
        $this->setIfExists('do_dangerous_products_delivery', $data, null);
        $this->setIfExists('do_transportation_oversized_cargo', $data, null);
        $this->setIfExists('add_partial_reject_service', $data, null);
        $this->setIfExists('add_insurance_service', $data, null);
        $this->setIfExists('add_fitting_service', $data, null);
        $this->setIfExists('add_return_service', $data, null);
        $this->setIfExists('add_open_service', $data, null);
        $this->setIfExists('pct', $data, null);
        $this->setIfExists('payment_methods', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор службы доставки
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Название
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets registered_at
     *
     * @return \DateTime|null
     */
    public function getRegisteredAt()
    {
        return $this->container['registered_at'];
    }

    /**
     * Sets registered_at
     *
     * @param \DateTime|null $registered_at Дата регистрации
     *
     * @return $this
     */
    public function setRegisteredAt($registered_at)
    {


        /*if (is_null($registered_at)) {
            throw new \InvalidArgumentException('non-nullable registered_at cannot be null');
        }*/
        $this->container['registered_at'] = $registered_at;

        return $this;
    }

    /**
     * Gets legal_info_company_name
     *
     * @return string|null
     */
    public function getLegalInfoCompanyName()
    {
        return $this->container['legal_info_company_name'];
    }

    /**
     * Sets legal_info_company_name
     *
     * @param string|null $legal_info_company_name Юр. название компании
     *
     * @return $this
     */
    public function setLegalInfoCompanyName($legal_info_company_name)
    {

        if (is_null($legal_info_company_name)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_company_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_company_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_company_name'] = $legal_info_company_name;

        return $this;
    }

    /**
     * Gets legal_info_company_address
     *
     * @return \Ensi\LogisticClient\Dto\Address|null
     */
    public function getLegalInfoCompanyAddress()
    {
        return $this->container['legal_info_company_address'];
    }

    /**
     * Sets legal_info_company_address
     *
     * @param \Ensi\LogisticClient\Dto\Address|null $legal_info_company_address legal_info_company_address
     *
     * @return $this
     */
    public function setLegalInfoCompanyAddress($legal_info_company_address)
    {

        if (is_null($legal_info_company_address)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_company_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_company_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_company_address'] = $legal_info_company_address;

        return $this;
    }

    /**
     * Gets legal_info_inn
     *
     * @return string|null
     */
    public function getLegalInfoInn()
    {
        return $this->container['legal_info_inn'];
    }

    /**
     * Sets legal_info_inn
     *
     * @param string|null $legal_info_inn ИНН
     *
     * @return $this
     */
    public function setLegalInfoInn($legal_info_inn)
    {

        if (is_null($legal_info_inn)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_inn');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_inn', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_inn'] = $legal_info_inn;

        return $this;
    }

    /**
     * Gets legal_info_payment_account
     *
     * @return string|null
     */
    public function getLegalInfoPaymentAccount()
    {
        return $this->container['legal_info_payment_account'];
    }

    /**
     * Sets legal_info_payment_account
     *
     * @param string|null $legal_info_payment_account р/с
     *
     * @return $this
     */
    public function setLegalInfoPaymentAccount($legal_info_payment_account)
    {

        if (is_null($legal_info_payment_account)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_payment_account');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_payment_account', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_payment_account'] = $legal_info_payment_account;

        return $this;
    }

    /**
     * Gets legal_info_bik
     *
     * @return string|null
     */
    public function getLegalInfoBik()
    {
        return $this->container['legal_info_bik'];
    }

    /**
     * Sets legal_info_bik
     *
     * @param string|null $legal_info_bik БИК
     *
     * @return $this
     */
    public function setLegalInfoBik($legal_info_bik)
    {

        if (is_null($legal_info_bik)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_bik');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_bik', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_bik'] = $legal_info_bik;

        return $this;
    }

    /**
     * Gets legal_info_bank
     *
     * @return string|null
     */
    public function getLegalInfoBank()
    {
        return $this->container['legal_info_bank'];
    }

    /**
     * Sets legal_info_bank
     *
     * @param string|null $legal_info_bank Банк
     *
     * @return $this
     */
    public function setLegalInfoBank($legal_info_bank)
    {

        if (is_null($legal_info_bank)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_bank');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_bank', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_bank'] = $legal_info_bank;

        return $this;
    }

    /**
     * Gets legal_info_bank_correspondent_account
     *
     * @return string|null
     */
    public function getLegalInfoBankCorrespondentAccount()
    {
        return $this->container['legal_info_bank_correspondent_account'];
    }

    /**
     * Sets legal_info_bank_correspondent_account
     *
     * @param string|null $legal_info_bank_correspondent_account К/с банка
     *
     * @return $this
     */
    public function setLegalInfoBankCorrespondentAccount($legal_info_bank_correspondent_account)
    {

        if (is_null($legal_info_bank_correspondent_account)) {
            array_push($this->openAPINullablesSetToNull, 'legal_info_bank_correspondent_account');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_info_bank_correspondent_account', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_info_bank_correspondent_account'] = $legal_info_bank_correspondent_account;

        return $this;
    }

    /**
     * Gets general_manager_name
     *
     * @return string|null
     */
    public function getGeneralManagerName()
    {
        return $this->container['general_manager_name'];
    }

    /**
     * Sets general_manager_name
     *
     * @param string|null $general_manager_name ФИО ген. директора
     *
     * @return $this
     */
    public function setGeneralManagerName($general_manager_name)
    {

        if (is_null($general_manager_name)) {
            array_push($this->openAPINullablesSetToNull, 'general_manager_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('general_manager_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['general_manager_name'] = $general_manager_name;

        return $this;
    }

    /**
     * Gets contract_number
     *
     * @return string|null
     */
    public function getContractNumber()
    {
        return $this->container['contract_number'];
    }

    /**
     * Sets contract_number
     *
     * @param string|null $contract_number Номер договора
     *
     * @return $this
     */
    public function setContractNumber($contract_number)
    {

        if (is_null($contract_number)) {
            array_push($this->openAPINullablesSetToNull, 'contract_number');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('contract_number', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['contract_number'] = $contract_number;

        return $this;
    }

    /**
     * Gets contract_date
     *
     * @return \DateTime|null
     */
    public function getContractDate()
    {
        return $this->container['contract_date'];
    }

    /**
     * Sets contract_date
     *
     * @param \DateTime|null $contract_date Дата договора
     *
     * @return $this
     */
    public function setContractDate($contract_date)
    {

        if (is_null($contract_date)) {
            array_push($this->openAPINullablesSetToNull, 'contract_date');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('contract_date', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['contract_date'] = $contract_date;

        return $this;
    }

    /**
     * Gets vat_rate
     *
     * @return int|null
     */
    public function getVatRate()
    {
        return $this->container['vat_rate'];
    }

    /**
     * Sets vat_rate
     *
     * @param int|null $vat_rate Cтавка НДС
     *
     * @return $this
     */
    public function setVatRate($vat_rate)
    {

        if (is_null($vat_rate)) {
            array_push($this->openAPINullablesSetToNull, 'vat_rate');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('vat_rate', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['vat_rate'] = $vat_rate;

        return $this;
    }

    /**
     * Gets taxation_type
     *
     * @return int|null
     */
    public function getTaxationType()
    {
        return $this->container['taxation_type'];
    }

    /**
     * Sets taxation_type
     *
     * @param int|null $taxation_type Тип налогообложения
     *
     * @return $this
     */
    public function setTaxationType($taxation_type)
    {

        if (is_null($taxation_type)) {
            array_push($this->openAPINullablesSetToNull, 'taxation_type');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('taxation_type', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['taxation_type'] = $taxation_type;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int|null $status status
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets comment
     *
     * @return string|null
     */
    public function getComment()
    {
        return $this->container['comment'];
    }

    /**
     * Sets comment
     *
     * @param string|null $comment Комментарий
     *
     * @return $this
     */
    public function setComment($comment)
    {

        if (is_null($comment)) {
            array_push($this->openAPINullablesSetToNull, 'comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['comment'] = $comment;

        return $this;
    }

    /**
     * Gets apiship_key
     *
     * @return string|null
     */
    public function getApishipKey()
    {
        return $this->container['apiship_key'];
    }

    /**
     * Sets apiship_key
     *
     * @param string|null $apiship_key Код в системе ApiShip
     *
     * @return $this
     */
    public function setApishipKey($apiship_key)
    {

        if (is_null($apiship_key)) {
            array_push($this->openAPINullablesSetToNull, 'apiship_key');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('apiship_key', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['apiship_key'] = $apiship_key;

        return $this;
    }

    /**
     * Gets priority
     *
     * @return int|null
     */
    public function getPriority()
    {
        return $this->container['priority'];
    }

    /**
     * Sets priority
     *
     * @param int|null $priority Приоритет (чем меньше, тем выше)
     *
     * @return $this
     */
    public function setPriority($priority)
    {


        /*if (is_null($priority)) {
            throw new \InvalidArgumentException('non-nullable priority cannot be null');
        }*/
        $this->container['priority'] = $priority;

        return $this;
    }

    /**
     * Gets max_shipments_per_day
     *
     * @return int|null
     */
    public function getMaxShipmentsPerDay()
    {
        return $this->container['max_shipments_per_day'];
    }

    /**
     * Sets max_shipments_per_day
     *
     * @param int|null $max_shipments_per_day Максимальное кол-во отправлений в день
     *
     * @return $this
     */
    public function setMaxShipmentsPerDay($max_shipments_per_day)
    {

        if (is_null($max_shipments_per_day)) {
            array_push($this->openAPINullablesSetToNull, 'max_shipments_per_day');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('max_shipments_per_day', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['max_shipments_per_day'] = $max_shipments_per_day;

        return $this;
    }

    /**
     * Gets max_cargo_export_time
     *
     * @return string|null
     */
    public function getMaxCargoExportTime()
    {
        return $this->container['max_cargo_export_time'];
    }

    /**
     * Sets max_cargo_export_time
     *
     * @param string|null $max_cargo_export_time Время создания заявки для забора отправления день-в-день
     *
     * @return $this
     */
    public function setMaxCargoExportTime($max_cargo_export_time)
    {

        if (is_null($max_cargo_export_time)) {
            array_push($this->openAPINullablesSetToNull, 'max_cargo_export_time');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('max_cargo_export_time', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['max_cargo_export_time'] = $max_cargo_export_time;

        return $this;
    }

    /**
     * Gets do_consolidation
     *
     * @return bool|null
     */
    public function getDoConsolidation()
    {
        return $this->container['do_consolidation'];
    }

    /**
     * Sets do_consolidation
     *
     * @param bool|null $do_consolidation Консолидация многоместных отправлений?
     *
     * @return $this
     */
    public function setDoConsolidation($do_consolidation)
    {


        /*if (is_null($do_consolidation)) {
            throw new \InvalidArgumentException('non-nullable do_consolidation cannot be null');
        }*/
        $this->container['do_consolidation'] = $do_consolidation;

        return $this;
    }

    /**
     * Gets do_deconsolidation
     *
     * @return bool|null
     */
    public function getDoDeconsolidation()
    {
        return $this->container['do_deconsolidation'];
    }

    /**
     * Sets do_deconsolidation
     *
     * @param bool|null $do_deconsolidation Расконсолидация многоместных отправлений?
     *
     * @return $this
     */
    public function setDoDeconsolidation($do_deconsolidation)
    {


        /*if (is_null($do_deconsolidation)) {
            throw new \InvalidArgumentException('non-nullable do_deconsolidation cannot be null');
        }*/
        $this->container['do_deconsolidation'] = $do_deconsolidation;

        return $this;
    }

    /**
     * Gets do_zero_mile
     *
     * @return bool|null
     */
    public function getDoZeroMile()
    {
        return $this->container['do_zero_mile'];
    }

    /**
     * Sets do_zero_mile
     *
     * @param bool|null $do_zero_mile Осуществляет нулевую милю?
     *
     * @return $this
     */
    public function setDoZeroMile($do_zero_mile)
    {


        /*if (is_null($do_zero_mile)) {
            throw new \InvalidArgumentException('non-nullable do_zero_mile cannot be null');
        }*/
        $this->container['do_zero_mile'] = $do_zero_mile;

        return $this;
    }

    /**
     * Gets do_express_delivery
     *
     * @return bool|null
     */
    public function getDoExpressDelivery()
    {
        return $this->container['do_express_delivery'];
    }

    /**
     * Sets do_express_delivery
     *
     * @param bool|null $do_express_delivery Осуществляет экспресс-доставку?
     *
     * @return $this
     */
    public function setDoExpressDelivery($do_express_delivery)
    {


        /*if (is_null($do_express_delivery)) {
            throw new \InvalidArgumentException('non-nullable do_express_delivery cannot be null');
        }*/
        $this->container['do_express_delivery'] = $do_express_delivery;

        return $this;
    }

    /**
     * Gets do_return
     *
     * @return bool|null
     */
    public function getDoReturn()
    {
        return $this->container['do_return'];
    }

    /**
     * Sets do_return
     *
     * @param bool|null $do_return Принимает возвраты?
     *
     * @return $this
     */
    public function setDoReturn($do_return)
    {


        /*if (is_null($do_return)) {
            throw new \InvalidArgumentException('non-nullable do_return cannot be null');
        }*/
        $this->container['do_return'] = $do_return;

        return $this;
    }

    /**
     * Gets do_dangerous_products_delivery
     *
     * @return bool|null
     */
    public function getDoDangerousProductsDelivery()
    {
        return $this->container['do_dangerous_products_delivery'];
    }

    /**
     * Sets do_dangerous_products_delivery
     *
     * @param bool|null $do_dangerous_products_delivery Осуществляет доставку опасных грузов?
     *
     * @return $this
     */
    public function setDoDangerousProductsDelivery($do_dangerous_products_delivery)
    {


        /*if (is_null($do_dangerous_products_delivery)) {
            throw new \InvalidArgumentException('non-nullable do_dangerous_products_delivery cannot be null');
        }*/
        $this->container['do_dangerous_products_delivery'] = $do_dangerous_products_delivery;

        return $this;
    }

    /**
     * Gets do_transportation_oversized_cargo
     *
     * @return bool|null
     */
    public function getDoTransportationOversizedCargo()
    {
        return $this->container['do_transportation_oversized_cargo'];
    }

    /**
     * Sets do_transportation_oversized_cargo
     *
     * @param bool|null $do_transportation_oversized_cargo Перевозка крупногабаритных грузов?
     *
     * @return $this
     */
    public function setDoTransportationOversizedCargo($do_transportation_oversized_cargo)
    {


        /*if (is_null($do_transportation_oversized_cargo)) {
            throw new \InvalidArgumentException('non-nullable do_transportation_oversized_cargo cannot be null');
        }*/
        $this->container['do_transportation_oversized_cargo'] = $do_transportation_oversized_cargo;

        return $this;
    }

    /**
     * Gets add_partial_reject_service
     *
     * @return bool|null
     */
    public function getAddPartialRejectService()
    {
        return $this->container['add_partial_reject_service'];
    }

    /**
     * Sets add_partial_reject_service
     *
     * @param bool|null $add_partial_reject_service Добавлять услугу частичного отказ в заказ на доставку?
     *
     * @return $this
     */
    public function setAddPartialRejectService($add_partial_reject_service)
    {


        /*if (is_null($add_partial_reject_service)) {
            throw new \InvalidArgumentException('non-nullable add_partial_reject_service cannot be null');
        }*/
        $this->container['add_partial_reject_service'] = $add_partial_reject_service;

        return $this;
    }

    /**
     * Gets add_insurance_service
     *
     * @return bool|null
     */
    public function getAddInsuranceService()
    {
        return $this->container['add_insurance_service'];
    }

    /**
     * Sets add_insurance_service
     *
     * @param bool|null $add_insurance_service Добавлять услугу страхования груза в заказ на доставку?
     *
     * @return $this
     */
    public function setAddInsuranceService($add_insurance_service)
    {


        /*if (is_null($add_insurance_service)) {
            throw new \InvalidArgumentException('non-nullable add_insurance_service cannot be null');
        }*/
        $this->container['add_insurance_service'] = $add_insurance_service;

        return $this;
    }

    /**
     * Gets add_fitting_service
     *
     * @return bool|null
     */
    public function getAddFittingService()
    {
        return $this->container['add_fitting_service'];
    }

    /**
     * Sets add_fitting_service
     *
     * @param bool|null $add_fitting_service Добавлять услугу примерки в заказ на доставку?
     *
     * @return $this
     */
    public function setAddFittingService($add_fitting_service)
    {


        /*if (is_null($add_fitting_service)) {
            throw new \InvalidArgumentException('non-nullable add_fitting_service cannot be null');
        }*/
        $this->container['add_fitting_service'] = $add_fitting_service;

        return $this;
    }

    /**
     * Gets add_return_service
     *
     * @return bool|null
     */
    public function getAddReturnService()
    {
        return $this->container['add_return_service'];
    }

    /**
     * Sets add_return_service
     *
     * @param bool|null $add_return_service Добавлять услугу возврата в заказ на доставку?
     *
     * @return $this
     */
    public function setAddReturnService($add_return_service)
    {


        /*if (is_null($add_return_service)) {
            throw new \InvalidArgumentException('non-nullable add_return_service cannot be null');
        }*/
        $this->container['add_return_service'] = $add_return_service;

        return $this;
    }

    /**
     * Gets add_open_service
     *
     * @return bool|null
     */
    public function getAddOpenService()
    {
        return $this->container['add_open_service'];
    }

    /**
     * Sets add_open_service
     *
     * @param bool|null $add_open_service Добавлять услугу вскрытия при получении в заказ на доставку?
     *
     * @return $this
     */
    public function setAddOpenService($add_open_service)
    {


        /*if (is_null($add_open_service)) {
            throw new \InvalidArgumentException('non-nullable add_open_service cannot be null');
        }*/
        $this->container['add_open_service'] = $add_open_service;

        return $this;
    }

    /**
     * Gets pct
     *
     * @return int|null
     */
    public function getPct()
    {
        return $this->container['pct'];
    }

    /**
     * Sets pct
     *
     * @param int|null $pct Planned Consolidation Time - плановое время доставки заказа от склада продавца до логистического хаба ЛО и обработки заказа в сортировочном центре или хабе на стороне ЛО (мин)
     *
     * @return $this
     */
    public function setPct($pct)
    {


        /*if (is_null($pct)) {
            throw new \InvalidArgumentException('non-nullable pct cannot be null');
        }*/
        $this->container['pct'] = $pct;

        return $this;
    }

    /**
     * Gets payment_methods
     *
     * @return int[]|null
     */
    public function getPaymentMethods()
    {
        return $this->container['payment_methods'];
    }

    /**
     * Sets payment_methods
     *
     * @param int[]|null $payment_methods payment_methods
     *
     * @return $this
     */
    public function setPaymentMethods($payment_methods)
    {


        /*if (is_null($payment_methods)) {
            throw new \InvalidArgumentException('non-nullable payment_methods cannot be null');
        }*/
        $this->container['payment_methods'] = $payment_methods;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


